Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Client.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Client.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Client.cs	(revision 995)
@@ -28,5 +28,5 @@
 namespace HeuristicLab.Hive.Contracts.BusinessObjects {
 
-  public enum State { idle, calculating, offline };
+  public enum State { nullState, idle, calculating, offline };
 
   [DataContract]
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/ClientConfig.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/ClientConfig.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/ClientConfig.cs	(revision 995)
@@ -29,7 +29,7 @@
 
   [DataContract]
-  public class ClientConfig {
+  public class ClientConfig: IHiveObject {
     [DataMember]
-    public long ClientConfigId { get; set; }
+    public long Id { get; set; }
     [DataMember]
     public String UpDownTimeCalendar { get; set; } // TODO define DataStructure
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/GrantedPermissions.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/GrantedPermissions.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/GrantedPermissions.cs	(revision 995)
@@ -29,7 +29,7 @@
   
   [DataContract]
-  public class GrantedPermissions {
+  public class GrantedPermissions: IHiveObject {
     [DataMember]
-    public long GrantedPermissionsId { get; set; }
+    public long Id { get; set; }
     [DataMember]
     public Permission Permission { get; set; }
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/IHiveObject.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/IHiveObject.cs	(revision 995)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/IHiveObject.cs	(revision 995)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Hive.Contracts.BusinessObjects {
+  public interface IHiveObject {
+    long Id { get; set;  }
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Job.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Job.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Job.cs	(revision 995)
@@ -29,7 +29,7 @@
 
   [DataContract]
-  public class Job {
+  public class Job: IHiveObject {
     [DataMember]
-    public long JobId { get; set; }
+    public long Id { get; set; }
     [DataMember]
     public State State { get; set; }
@@ -38,4 +38,15 @@
     [DataMember]
     public Job ParentJob { get; set; }
+
+    public override bool Equals(object obj) {
+      if (obj is Job) {
+        return (obj as Job).Id.Equals(Id);
+      } else      
+        return base.Equals(obj);
+    }
+
+    public override int GetHashCode() {
+      return Id.GetHashCode();
+    }
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/JobResult.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/JobResult.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/JobResult.cs	(revision 995)
@@ -29,7 +29,7 @@
 
   [DataContract]
-  public class JobResult {
+  public class JobResult: IHiveObject {
     [DataMember]
-    public long JobResultId { get; set; }
+    public long Id { get; set; }
     [DataMember]
     public long JobId { get; set; }
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Permission.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Permission.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Permission.cs	(revision 995)
@@ -29,7 +29,7 @@
 
   [DataContract]
-  public class Permission {
+  public class Permission: IHiveObject {
     [DataMember]
-    public long PermissionId { get; set; }
+    public long Id { get; set; }
     [DataMember]
     public String Name { get; set; }
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/PermissionOwner.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/PermissionOwner.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/PermissionOwner.cs	(revision 995)
@@ -29,7 +29,7 @@
 
   [DataContract]
-  public class PermissionOwner {
+  public class PermissionOwner: IHiveObject {
     [DataMember]
-    public long PermissionOwnerId { get; set; }
+    public long Id { get; set; }
     [DataMember]
     public string Name { get; set; }
@@ -37,6 +37,6 @@
     public override bool Equals(object obj) {
       if (obj is PermissionOwner) 
-        return this.PermissionOwnerId.Equals(
-          (obj as PermissionOwner).PermissionOwnerId);
+        return this.Id.Equals(
+          (obj as PermissionOwner).Id);
       else
         return base.Equals(obj);
@@ -44,5 +44,5 @@
 
     public override int GetHashCode() {
-      return this.PermissionOwnerId.GetHashCode();
+      return this.Id.GetHashCode();
     }
   }
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Resource.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Resource.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Resource.cs	(revision 995)
@@ -29,10 +29,20 @@
 
   [DataContract]
-  public class Resource {
+  public class Resource: IHiveObject {
     [DataMember]
-    public long ResourceId { get; set; }
+    public long Id { get; set; }
     [DataMember]
     public string Name { get; set; }
 
+    public override bool Equals(object obj) {
+      if (obj is Resource)
+        return (obj as Resource).Id.Equals(Id);
+      else
+        return base.Equals(obj);
+    }
+
+    public override int GetHashCode() {
+      return Id.GetHashCode();
+    }
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/UpTimeStatistics.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/UpTimeStatistics.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/UpTimeStatistics.cs	(revision 995)
@@ -29,7 +29,7 @@
 
   [DataContract]
-  public class UpTimeStatistics {
+  public class UpTimeStatistics: IHiveObject {
     [DataMember]
-    public long UpTimeStatisticsId { get; set; }
+    public long Id { get; set; }
     [DataMember]
     public ClientInfo Client { get; set; }
Index: trunk/sources/HeuristicLab.Hive.Contracts/HeuristicLab.Hive.Contracts.csproj
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/HeuristicLab.Hive.Contracts.csproj	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Contracts/HeuristicLab.Hive.Contracts.csproj	(revision 995)
@@ -74,4 +74,5 @@
     <Compile Include="BusinessObjects\ClientGroup.cs" />
     <Compile Include="BusinessObjects\HeartBeatData.cs" />
+    <Compile Include="BusinessObjects\IHiveObject.cs" />
     <Compile Include="BusinessObjects\Job.cs" />
     <Compile Include="BusinessObjects\JobResult.cs" />
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/CachedDataAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/CachedDataAdapter.cs	(revision 995)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/CachedDataAdapter.cs	(revision 995)
@@ -0,0 +1,182 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using System.Runtime.CompilerServices;
+
+namespace HeuristicLab.Hive.Server.ADODataAccess {
+  abstract class CachedDataAdapter<AdapterT, ObjT, RowT, CacheT> :
+    DataAdapterBase<AdapterT, ObjT, RowT>, 
+    ICachedDataAdapter
+    where CacheT: System.Data.TypedTableBase<RowT>, new()
+    where AdapterT : new()
+    where RowT : System.Data.DataRow
+    where ObjT : IHiveObject, new() {
+    protected CacheT cache = 
+      new CacheT();
+
+    protected ICollection<ICachedDataAdapter> parentAdapters =
+      new List<ICachedDataAdapter>();
+
+    protected CachedDataAdapter() {
+      FillCache();
+
+      ServiceLocator.GetTransactionManager().OnUpdate +=
+        new EventHandler(CachedDataAdapter_OnUpdate);
+    }
+
+    protected virtual RowT FindSingleRow(Selector dbSelector, 
+      Selector cacheSelector) {
+      RowT row =
+         FindSingleRow(cacheSelector);
+
+      //not in cache
+      if (row == null) {
+        row =
+          FindSingleRow(dbSelector);
+      }
+
+      return row;
+    }
+
+    protected virtual IEnumerable<RowT> FindMultipleRows(Selector dbSelector,
+        Selector cacheSelector) {
+      IList<RowT> result =
+         new List<RowT>(cacheSelector());
+
+      IEnumerable<RowT> result2 =
+          dbSelector();
+
+      foreach (RowT row in result2) {
+        if (!IsCached(row)) {
+          result.Add(row);
+        }
+      }
+
+      return result;
+    }
+
+    protected virtual ObjT FindSingle(Selector dbSelector,
+      Selector cacheSelector) {
+      RowT row = FindSingleRow(dbSelector, cacheSelector);
+
+      if (row != null) {
+        ObjT obj = new ObjT();
+        Convert(row, obj);
+
+        return obj;
+      } else {
+        return default(ObjT);
+      }
+    }
+
+    protected virtual ICollection<ObjT> FindMultiple(Selector dbSelector,
+      Selector cacheSelector) {
+      ICollection<ObjT> result =
+        FindMultiple(cacheSelector);
+
+      ICollection<ObjT> resultDb =
+        FindMultiple(dbSelector);
+
+      foreach (ObjT obj in resultDb) {
+        if (!result.Contains(obj))
+          result.Add(obj);
+      }
+
+      return result;
+    }
+
+    protected abstract RowT InsertNewRowInCache(ObjT obj);
+
+    protected abstract void FillCache();
+
+    public abstract void SyncWithDb();
+
+    protected abstract bool PutInCache(ObjT obj);
+
+    protected abstract RowT FindCachedById(long id);
+
+    void CachedDataAdapter_OnUpdate(object sender, EventArgs e) {
+      foreach (ICachedDataAdapter parent in this.parentAdapters) {
+        parent.SyncWithDb();
+      }
+
+      this.SyncWithDb();
+    }
+
+    protected virtual void RemoveRowFromCache(RowT row) {
+      cache.Rows.Remove(row);
+    }
+
+    protected virtual bool IsCached(RowT row) {
+      return cache.Contains<RowT>(row);
+    }
+
+    protected override RowT GetRowById(long id) {
+      RowT row =
+        FindCachedById(id);
+      
+      if(row == null)
+        row = FindSingleRow(
+          delegate() {
+            return FindById(id);
+          });
+
+      return row;
+    }
+
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public override void Update(ObjT obj) {
+      if (obj != null) {
+        RowT row = 
+          GetRowById(obj.Id);
+
+        if (row == null) {
+          if (PutInCache(obj)) {
+            row = InsertNewRowInCache(obj);
+          } else {
+            row = InsertNewRow(obj);
+          }
+
+          UpdateRow(row);
+        }
+
+        Convert(obj, row);
+
+        if (IsCached(row) &&
+            !PutInCache(obj)) {
+          //remove from cache
+          UpdateRow(row);
+          RemoveRowFromCache(row);
+        }
+
+        obj.Id = (long)row[row.Table.PrimaryKey[0]];
+
+        if (!IsCached(row))
+          UpdateRow(row);
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientAdapter.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientAdapter.cs	(revision 995)
@@ -30,10 +30,14 @@
 
 namespace HeuristicLab.Hive.Server.ADODataAccess {
-  class ClientAdapter: DataAdapterBase, IClientAdapter {
-    private dsHiveServerTableAdapters.ClientTableAdapter adapter =
-        new dsHiveServerTableAdapters.ClientTableAdapter();
-
-    private dsHiveServer.ClientDataTable data =
-      new dsHiveServer.ClientDataTable();
+  class ClientAdapter: 
+    CachedDataAdapter<
+      dsHiveServerTableAdapters.ClientTableAdapter, 
+      ClientInfo, 
+      dsHiveServer.ClientRow, 
+      dsHiveServer.ClientDataTable>,
+    IClientAdapter {
+    #region Fields
+    dsHiveServer.ClientDataTable data =
+        new dsHiveServer.ClientDataTable();
 
     private IResourceAdapter resAdapter = null;
@@ -71,22 +75,23 @@
       }
     }
+    #endregion
 
     public ClientAdapter() {
-      adapter.Fill(data);
-    }
-
-    protected override void Update() {
-      this.adapter.Update(this.data);
-    }
-    
-    private ClientInfo Convert(dsHiveServer.ClientRow row, 
+      parentAdapters.Add(this.ResAdapter as ICachedDataAdapter);
+    }
+
+    #region Overrides
+    protected override ClientInfo Convert(dsHiveServer.ClientRow row, 
       ClientInfo client) {
       if(row != null && client != null) {      
         /*Parent - resource*/
-        client.ResourceId = row.ResourceId;
-        ResAdapter.GetResourceById(client);
+        client.Id = row.ResourceId;
+        ResAdapter.GetById(client);
 
         /*ClientInfo*/
-        client.ClientId = row.GUID;
+        if (!row.IsGUIDNull())
+          client.ClientId = row.GUID;
+        else
+          client.ClientId = Guid.Empty;
        
         if (!row.IsCPUSpeedNull())
@@ -108,5 +113,5 @@
           client.State = (State)Enum.Parse(typeof(State), row.Status, true);
         else
-          client.State = State.idle;
+          client.State = State.nullState;
 
         if (!row.IsNumberOfCoresNull())
@@ -123,5 +128,5 @@
     }
 
-    private dsHiveServer.ClientRow Convert(ClientInfo client,
+    protected override dsHiveServer.ClientRow Convert(ClientInfo client,
       dsHiveServer.ClientRow row) {
       if (client != null && row != null) {      
@@ -130,5 +135,8 @@
         row.Memory = client.Memory;
         row.Login = client.Login;
-        row.Status = client.State.ToString();
+        if (client.State != State.nullState)
+          row.Status = client.State.ToString();
+        else
+          row.SetStatusNull();
         row.NumberOfCores = client.NrOfCores;
 
@@ -143,102 +151,93 @@
     }
 
+    protected override void UpdateRow(dsHiveServer.ClientRow row) {
+      adapter.Update(row);
+    }
+
+    protected override dsHiveServer.ClientRow
+      InsertNewRow(ClientInfo client) {
+      dsHiveServer.ClientRow row = data.NewClientRow();
+      row.ResourceId = client.Id;
+      data.AddClientRow(row);
+
+      return row;
+    }
+
+    protected override dsHiveServer.ClientRow
+      InsertNewRowInCache(ClientInfo client) {
+      dsHiveServer.ClientRow row = cache.NewClientRow();
+      row.ResourceId = client.Id;
+      cache.AddClientRow(row);
+
+      return row;
+    }
+
+    protected override void FillCache() {
+      cache = adapter.GetDataByActive();
+    }
+
+    public override void SyncWithDb() {
+      adapter.Update(cache);
+    }
+
+    protected override bool PutInCache(ClientInfo obj) {
+      return (obj.State != State.offline && obj.State != State.nullState);
+    }
+
+    protected override IEnumerable<dsHiveServer.ClientRow>
+      FindById(long id) {
+      return adapter.GetDataByResourceId(id);
+    }
+
+    protected override dsHiveServer.ClientRow
+      FindCachedById(long id) {
+      return cache.FindByResourceId(id);
+    }
+
+    protected override IEnumerable<dsHiveServer.ClientRow>
+      FindAll() {
+      return FindMultipleRows(
+        new Selector(adapter.GetData),
+        new Selector(cache.AsEnumerable<dsHiveServer.ClientRow>));
+    }
+    #endregion
+
     #region IClientAdapter Members
     [MethodImpl(MethodImplOptions.Synchronized)]
-    public void UpdateClient(ClientInfo client) {
+    public override void Update(ClientInfo client) {
       if (client != null) {
-        ResAdapter.UpdateResource(client);
-
-        dsHiveServer.ClientRow row = 
-          data.FindByResourceId(client.ResourceId);
-
-        if (row == null) {
-          row = data.NewClientRow();
-          row.ResourceId = client.ResourceId;
-          data.AddClientRow(row);
-        } 
-
-        Convert(client, row);
-      }
-    }
-
-    public ClientInfo GetClientById(Guid clientId) {
+        ResAdapter.Update(client);
+
+        base.Update(client);
+      }
+    }
+
+    public ClientInfo GetById(Guid clientId) {
+      return base.FindSingle(
+        delegate() {
+          return adapter.GetDataById(clientId);
+        }, 
+        delegate() {
+          return from c in
+                     cache.AsEnumerable<dsHiveServer.ClientRow>()
+                   where !c.IsGUIDNull() && 
+                          c.GUID == clientId
+                   select c; 
+        });
+    }
+
+    public ClientInfo GetByName(string name) {
       ClientInfo client = new ClientInfo();
-
-      dsHiveServer.ClientRow row = null;
-      IEnumerable<dsHiveServer.ClientRow> clients =
-            from c in
-              data.AsEnumerable<dsHiveServer.ClientRow>()
-            where !c.IsGUIDNull() && c.GUID == clientId
-            select c;
-      if (clients.Count<dsHiveServer.ClientRow>() == 1)
-        row = clients.First<dsHiveServer.ClientRow>();
-
-      if (row != null) {
-        Convert(row, client);
-
-        return client;
-      } else {
-        return null;
-      }
-    }
-
-    public ClientInfo GetClientById(long id) {
-      ClientInfo client = new ClientInfo();
-
-      dsHiveServer.ClientRow row = data.FindByResourceId(id);
-
-      if (row != null) {
-        Convert(row, client);
-
-        return client;
-      } else {
-        return null;
-      }
-    }
-
-    public ClientInfo GetClientByName(string name) {
-      ClientInfo client = new ClientInfo();
-
       Resource res =
-        ResAdapter.GetResourceByName(name);
-
-      if (res != null) {
+        ResAdapter.GetByName(name);
+
+      return GetById(res.Id);
+    }
+
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public override bool Delete(ClientInfo client) {      
+      if (client != null) {
         dsHiveServer.ClientRow row =
-          data.FindByResourceId(res.ResourceId);
-
-        if (row != null) {
-          Convert(row, client);
-
-          return client;
-        }
-      }
-
-      return null;
-    }
-
-    public ICollection<ClientInfo> GetAllClients() {
-      ICollection<ClientInfo> allClients =
-        new List<ClientInfo>();
-
-      foreach (dsHiveServer.ClientRow row in data) {
-        ClientInfo client = new ClientInfo();
-        Convert(row, client);
-        allClients.Add(client);
-      }
-
-      return allClients;
-    }
-
-    [MethodImpl(MethodImplOptions.Synchronized)]
-    public bool DeleteClient(ClientInfo client) {      
-      if (client != null) {
-        dsHiveServer.ClientRow row = null;
-        IEnumerable<dsHiveServer.ClientRow> clients =
-              from c in
-                data.AsEnumerable<dsHiveServer.ClientRow>()
-              where !c.IsGUIDNull() && c.GUID == client.ClientId
-              select c;
-        if (clients.Count<dsHiveServer.ClientRow>() == 1)
-          row = clients.First<dsHiveServer.ClientRow>();
+          GetRowById(client.Id);
 
         if (row != null) {
@@ -248,5 +247,5 @@
           foreach (ClientGroup group in clientGroups) {
             group.Resources.Remove(client);
-            ClientGroupAdapter.UpdateClientGroup(group);
+            ClientGroupAdapter.Update(group);
           }
 
@@ -255,11 +254,9 @@
             JobAdapter.GetJobsOf(client);
           foreach (Job job in jobs) {
-            JobAdapter.DeleteJob(job);
+            JobAdapter.Delete(job);
           }
 
-          row.Delete();
-          adapter.Update(row);
-
-          return ResAdapter.DeleteResource(client);
+          return base.Delete(client) && 
+            ResAdapter.Delete(client);
         }
       }
